//
// Created by lun on 2021/5/25.
//

#include <stdio.h>
#include <stdlib.h>
//#include <getopt.h>
#include <string.h>
#include <stdbool.h>
#include "Hashmap_acc2line.h"
#include "virus.h"
#include "optionparser.h"

extern "C" {
    void readVCF_acc2line_hash(const char* str_vcf, const char* str_mut, struct Hashmap_acc2line *hash);
    void readMut_acc2line_hash(char *str_input, struct Hashmap_acc2line *hash);
    void readMeta_acc2line_hash(char *str_input, struct Hashmap_acc2line *hash);
    bool chomp(char *str);
    bool emptyStr(char * str);
    void readDate2Date(char * str_date, struct Date * pDate);
    int cmp_time_date(const void* _a, const void* _b);
    void location_init(struct Location * pLocation);
    void extractDateFromMetaLine(const char *line, struct Date *pDate);
    void extractLocationFromMetaLine(const char *line, struct Location *pLocation);
    void version();
    int main_genDataset(int argc, char* argv[]);
}

/*
void extractDateFromMetaLine(char *line, struct Date *pDate){
    char *cpLine = (char *)malloc(sizeof(char) * (1 + strlen(line)));
    strcpy(cpLine, line);
    chomp(cpLine);
    char * r = cpLine;
    int columnIndex = 0; //column index starting from 0
    for (char * token1 =strsep(&r,"\t"); token1!=NULL; token1=strsep(&r,"\t")) {
        if(7 == columnIndex){ //8th column, date
            if(emptyStr(token1)){
                break;
            }
            readDate2Date(token1, pDate);
        }
        columnIndex ++;
    }
    //free
    free(cpLine);
    cpLine = NULL;
}
*/
void dateFilter(struct Hashmap_acc2line *pMeta, char *str_start_time, char *str_end_time, char *str_ref, char *str_time_accuracy){
    struct Date startDate, endDate, tmpDate;
    readDate2Date(str_start_time, &startDate);
    readDate2Date(str_end_time, &endDate);
    const char *acc, *line;
    //char *temp;
    //hashmap_foreach_safe(acc, line, &(pMeta->acc2line), temp) {
    for (auto it = pMeta->acc2line.begin(); it != pMeta->acc2line.end();) {
        acc = it->first.c_str();
        line = it->second.c_str();

        if(0 == strcmp(str_ref, acc)){//keep ref
            ++it;
            continue;
        }
        extractDateFromMetaLine(line, &tmpDate);

        if(0 == strcmp("month", str_time_accuracy)){
            if(-1 == tmpDate.year || -1 == tmpDate.month){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
            tmpDate.day = -1;
            startDate.day = -1;
            endDate.day = -1;
        }
        else if(0 == strcmp("day", str_time_accuracy)){
            if(-1 == tmpDate.year || -1 == tmpDate.month || -1 == tmpDate.day){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
        }
        else if(0 == strcmp("year", str_time_accuracy)){
            if(-1 == tmpDate.year){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
            tmpDate.day = -1;
            startDate.day = -1;
            endDate.day = -1;
            tmpDate.month = -1;
            startDate.month = -1;
            endDate.month = -1;
        }

        if(cmp_time_date(&tmpDate, &startDate) < 0 || cmp_time_date(&tmpDate, &endDate) > 0){
            //hashmap_remove(&(pMeta->acc2line), acc);
            //free(acc);
            //acc = NULL;
            //free(line);
            //line = NULL;
            it = pMeta->acc2line.erase(it);
            continue;
        }

        ++it;
    }
}
/*
void extractLocationFromMetaLine(char *line, struct Location *pLocation){
    location_init(pLocation);
    char *cpLine = (char *)malloc(sizeof(char) * (1 + strlen(line)));
    strcpy(cpLine, line);
    chomp(cpLine);
    char * r = cpLine;
    int columnIndex = 0; //column index starting from 0
    for (char * token1 =strsep(&r,"\t"); token1!=NULL; token1=strsep(&r,"\t")) {
        if(12 == columnIndex) { //country
            if(emptyStr(token1)){
                break;//next line
            }
            pLocation->country = (char *)malloc(sizeof(char) * (1+strlen(token1)));
            strcpy(pLocation->country, token1);
        }
        if(13 == columnIndex) { //country
            if(emptyStr(token1)){
                break;//next line
            }
            pLocation->state = (char *)malloc(sizeof(char) * (1+strlen(token1)));
            strcpy(pLocation->state, token1);
        }
        if(14 == columnIndex) { //country
            if(emptyStr(token1)){
                break;//next line
            }
            pLocation->city = (char *)malloc(sizeof(char) * (1+strlen(token1)));
            strcpy(pLocation->city, token1);
        }
        columnIndex ++;
    }
    //free
    free(cpLine);
    cpLine = NULL;
}
*/
void locationFilter(struct Hashmap_acc2line *pMeta, char *str_ref, char *str_country, char *str_state, char *str_city){
    const char *acc, *line;
    //char *temp;
    struct Location location;
    //hashmap_foreach_safe(acc, line, &(pMeta->acc2line), temp) {
    for (auto it = pMeta->acc2line.begin(); it != pMeta->acc2line.end();) {
        acc = it->first.c_str();
        line = it->second.c_str();
        if (0 == strcmp(str_ref, acc)) {//keep ref
            ++it;
            continue;
        }
        extractLocationFromMetaLine(line, &location);
        if(NULL != str_country){
            if(0 != strcmp(location.country, str_country)){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
        }
        if(NULL != str_state && NULL != location.state){
            if(0 != strcmp(location.state, str_state)){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
        }
        if(NULL != str_city && NULL != location.city){
            if(0 != strcmp(location.city, str_city)){
                //hashmap_remove(&(pMeta->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMeta->acc2line.erase(it);
                continue;
            }
        }
        ++it;
    }
}

void write_HashMutMeta(struct Hashmap_acc2line *pMut, struct Hashmap_acc2line *pMeta, char *str_outputMut, char *str_outputMeta){
    FILE *fpoutMut = fopen(str_outputMut, "w");
    if(NULL == fpoutMut){
        fprintf(stderr, "\nError: failed to create file: %s\n", str_outputMut);
        exit(1);
    }
    FILE *fpoutMeta = fopen(str_outputMeta, "w");
    if(NULL == fpoutMeta){
        fprintf(stderr, "\nError: failed to create file: %s\n", str_outputMeta);
        exit(1);
    }
    const char /**acc,*/ *lineMeta, *lineMut;
    //hashmap_foreach(acc, lineMeta, &(pMeta->acc2line)) {
    for (auto& elem : pMeta->acc2line) {
        auto it = pMut->acc2line.find(elem.first);
        //if(NULL != lineMut){
        if (it != pMut->acc2line.end()) {
            lineMut = it->second.c_str();
            lineMeta = elem.second.c_str();
            fprintf(fpoutMut, "%s\n", lineMut);
            fprintf(fpoutMeta, "%s\n", lineMeta);
        }
    }
    //printf("%d\t%d\n",(int)hashmap_size(&(pMut->acc2line)), (int)hashmap_size(&(pMeta->acc2line)));
    //close
    fclose(fpoutMut);
    fpoutMut = NULL;
    fclose(fpoutMeta);
    fpoutMeta = NULL;
}

void remove_unmatched(struct Hashmap_acc2line *pHash1, struct Hashmap_acc2line *pHash2){
    //char *acc, *line1, *line2;
    //void *temp;

    //hashmap_foreach_safe(acc, line1, &(pHash1->acc2line), temp) {
    for (auto it = pHash1->acc2line.begin(); it != pHash1->acc2line.end();) {
        //line2 = NULL;
        //line2 = hashmap_get(&(pHash2->acc2line), acc);
        auto it2 = pHash2->acc2line.find(it->first);
        //if(NULL == line2){
        if (it2 == pHash2->acc2line.end()) {
            //hashmap_remove(&(pHash1->acc2line), acc);
            //free(acc);
            //acc = NULL;
            //free(line1);
            //line1 = NULL;
            it = pHash1->acc2line.erase(it);
        }
        else
            ++it;
    }
}
void match_MutMeta(struct Hashmap_acc2line *pMut, struct Hashmap_acc2line *pMeta){
    remove_unmatched(pMut, pMeta);
    remove_unmatched(pMeta, pMut);
}

void randomSample(struct Hashmap_acc2line *pMut, int numOfOutLine, char *str_ref){
    int numOfLine = pMut->acc2line.size() - 1;//exclude ref
    int numOfDelet = numOfLine - numOfOutLine + 1;//num of line need to be deleted
    bool *keep = (bool *)malloc(sizeof(bool) * (numOfLine));//exclude ref
    for (int i = 0; i < numOfLine; ++i) {
        keep[i] = true;
    }

    int count = 0;
    while(count < numOfDelet){
        int index = rand()%numOfLine;
        if(true == keep[index]){
            keep[index] = false;
            count ++;
        }
    }

    const char *acc = NULL/*, *line = NULL*/;
    //void *temp;
    count = 0;
    //hashmap_foreach_safe(acc, line, &(pMut->acc2line), temp) {
    for (auto it = pMut->acc2line.begin(); it != pMut->acc2line.end();) {
        acc = it->first.c_str();
        if(0 != strcmp(acc, str_ref)){
            count ++;
            if(false == keep[count]){
                //hashmap_remove(&(pMut->acc2line), acc);
                //free(acc);
                //acc = NULL;
                //free(line);
                //line = NULL;
                it = pMut->acc2line.erase(it);
                continue;
            }
        }
        ++it;
    }
}

void genDataset(char *str_inputVCF, char *str_inputMut, char *str_outputMut, char *str_inputMeta, char *str_outputMeta, int numOfOutLine, char *str_ref, char * str_start_time, char * str_end_time, char *str_time_accuracy, char *str_country, char *str_state, char *str_city){
    //read Mut and Meta
    struct Hashmap_acc2line pMut;
    if (str_inputVCF) {
        readVCF_acc2line_hash(str_inputVCF, NULL, &pMut);
    }
    if (str_inputMut) {
        readMut_acc2line_hash(str_inputMut, &pMut);
    }
    struct Hashmap_acc2line pMeta;
    readMeta_acc2line_hash(str_inputMeta, &pMeta);
    //printf("mut\tmeta\n");
    //printf("%d\t%d\n",(int)hashmap_size(&(pMut.acc2line)), (int)hashmap_size(&(pMeta.acc2line)));

    //match
    match_MutMeta(&pMut, &pMeta);

    //time filter
    if(NULL != str_start_time && NULL != str_end_time && NULL != str_ref && NULL != str_time_accuracy){
        dateFilter(&pMeta, str_start_time, str_end_time, str_ref, str_time_accuracy);
        match_MutMeta(&pMut, &pMeta);
    }

    //location filter
    if(NULL != str_ref && NULL != str_country){
        locationFilter(&pMeta, str_ref, str_country, str_state, str_city);
        match_MutMeta(&pMut, &pMeta);
    }

    //sample randomly
    int numOfLine = pMut.acc2line.size();
    if(numOfOutLine > 0 && numOfLine > numOfOutLine && NULL != str_ref){
        randomSample(&pMut, numOfOutLine, str_ref);
        match_MutMeta(&pMut, &pMeta);
    }

    //write mut and meta
    write_HashMutMeta(&pMut, &pMeta, str_outputMut, str_outputMeta);

    //free (all hash..)
    //char *acc, *lineMeta, *lineMut;
    //hashmap_foreach(acc, lineMeta, &(pMeta.acc2line)) {
    //    free(acc);
    //    acc = NULL;
    //    free(lineMeta);
    //    lineMeta = NULL;
    //}
    //hashmap_foreach(acc, lineMut, &(pMut.acc2line)) {
    //    free(acc);
    //    acc = NULL;
    //    free(lineMut);
    //    lineMut = NULL;
    //}
    //hashmap_cleanup(&(pMeta.acc2line));
    //hashmap_cleanup(&(pMut.acc2line));
}

namespace GenDataset {

void help() {
    printf("Usage: McAN genDataset [option]...\n\n");

    printf("Options:\n");
    printf("  -f, --vcf <file>              input vcf file\n");
    printf("  -u, --mutation <file>         input mutation file\n");
    printf("  -m, --meta <file>             input meta file\n");
    printf("  -r, --ref <string>            accession ID of reference sample\n");
    printf("  -n, --nsample <int>           maximum number of samples\n");
    printf("  -s, --start-time <string>     earliest sampling date\n");
    printf("  -e, --end-time <string>       latest sampling date\n");
    printf("  -a, --time-accuracy <string>  year, month or day\n");
    printf("  -y, --country <string>\n");
    printf("  -t, --state <string>\n");
    printf("  -c, --city <string>\n");
    printf("  -U, --out-mutation <file>     output mutation file\n");
    printf("  -M, --out-meta <file>         output meta file\n\n");

    printf("  -h, --help                    display this help and exit\n");
    printf("  -v, --version                 output version information and exit\n");
}

enum EOption {
    Evcf = 0,
    Emutation,
    Emeta,
    Eref,
    Ensample,
    Estarttime,
    Eendtime,
    Etimeaccuracy,
    Ecountry,
    Estate,
    Ecity,
    Eoutmutation,
    Eoutmeta,
    Eversion,
    Ehelp,
    ELast
};

typedef struct {
    const char* vcf;
    const char* mutation;
    const char* meta;
    const char* ref;
    const char* nsample;
    const char* starttime;
    const char* endtime;
    const char* timeaccuracy;
    const char* country;
    const char* state;
    const char* city;
    const char* outmutation;
    const char* outmeta;
    bool version;
    bool help;
    bool used[ELast];
} Argument;

bool getOptions(int argc, char* argv[], Argument* arg) {
    if (argc <= 1) {
        help();
        return false;
    }

    static const Option options[] = {
        { "--vcf", 1, Evcf },
        { "--mutation", 1, Emutation },
        { "--meta", 1, Emeta },
        { "--ref", 1, Eref },
        { "--nsample", 1, Ensample },
        { "--start-time", 1, Estarttime },
        { "--end-time", 1, Eendtime },
        { "--time-accuracy", 1, Etimeaccuracy },
        { "--country", 1, Ecountry },
        { "--state", 1, Estate },
        { "--city", 1, Ecity },
        { "--out-mutation", 1, Eoutmutation },
        { "--out-meta", 1, Eoutmeta },
        { "--version", 0, Eversion },
        { "--help", 0, Ehelp },
        { "-f", 1, Evcf },
        { "-u", 1, Emutation },
        { "-m", 1, Emeta },
        { "-r", 1, Eref },
        { "-n", 1, Ensample },
        { "-s", 1, Estarttime },
        { "-e", 1, Eendtime },
        { "-a", 1, Etimeaccuracy },
        { "-y", 1, Ecountry },
        { "-t", 1, Estate },
        { "-c", 1, Ecity },
        { "-U", 1, Eoutmutation },
        { "-M", 1, Eoutmeta },
        { "-v", 0, Eversion },
        { "-h", 0, Ehelp }
    };


    return ArgParser::parseCommandLine(argc, argv, options, LENGTH_OF(options), 1, 1, [arg](Arg a) {
        int i = a.id;
        const char* val = a.val;

        if (arg->used[i])
            return ERepeated;
        arg->used[i] = true;

        char* pEnd;
        int inum = 0;

        if (i == Ensample) {
            inum = (int)strtol(val, &pEnd, 10);
            if (*pEnd != 0)
                return EInvalid;
        }

        switch (i)
        {
        case Evcf:
            arg->vcf = val;
            break;
        case Emutation:
            arg->mutation = val;
            break;
        case Emeta:
            arg->meta = val;
            break;
        case Eref:
            arg->ref = val;
            break;
        case Ensample:
            arg->nsample = val;
            break;
        case Estarttime:
            arg->starttime = val;
            break;
        case Eendtime:
            arg->endtime = val;
            break;
        case Etimeaccuracy:
            arg->timeaccuracy = val;
            break;
        case Ecountry:
            arg->country = val;
            break;
        case Estate:
            arg->state = val;
            break;
        case Ecity:
            arg->city = val;
            break;
        case Eoutmutation:
            arg->outmutation = val;
            break;
        case Eoutmeta:
            arg->outmeta = val;
            break;
        case Eversion:
            version();
            return ESuccessEnd;
        case Ehelp:
            help();
            return ESuccessEnd;
        default:
            return EInvalid;
        }

        return ESuccess;
    });
}

}

void opt_genDataset(int argc, char **argv){
    using namespace GenDataset;

    char * str_inputVCF = NULL;
    char * str_inputMut = NULL;
    char * str_outputMut = NULL;
    char * str_inputMeta = NULL;
    char * str_outputMeta = NULL;
    char * str_outNumber = NULL;
    char * str_ref = NULL;
    char * str_start_time = NULL;
    char * str_end_time = NULL;
    char * str_time_accuracy = NULL;
    char * str_country = NULL;
    char * str_state = NULL;
    char * str_city = NULL;

    //bool bool_help = false;
    int numOfOutLine = -1;
    //int c;

    Argument arg;
    memset(&arg, 0, sizeof(arg));
    if (!getOptions(argc, argv, &arg))
        exit(EXIT_FAILURE);
    else if (arg.used[Ehelp] || arg.used[Eversion])
        exit(EXIT_SUCCESS);

    if (arg.vcf) {
        str_inputVCF = (char *)malloc(sizeof(char) * (1 + strlen(arg.vcf)));
        strcpy(str_inputVCF, arg.vcf);
    }
    if (arg.mutation) {
        str_inputMut = (char *)malloc(sizeof(char) * (1 + strlen(arg.mutation)));
        strcpy(str_inputMut, arg.mutation);
    }
    if (arg.meta) {
        str_inputMeta = (char *)malloc(sizeof(char) * (1 + strlen(arg.meta)));
        strcpy(str_inputMeta, arg.meta);
    }
    if (arg.ref) {
        str_ref = (char *)malloc(sizeof(char) * (1 + strlen(arg.ref))); // the last char store '\0'
        strcpy(str_ref, arg.ref);
    }
    if (arg.nsample) {
        str_outNumber = (char *)malloc(sizeof(char) * (1 + strlen(arg.nsample))); // the last char store '\0'
        strcpy(str_outNumber, arg.nsample);
        numOfOutLine = atoi(str_outNumber);
    }
    if (arg.starttime) {
        str_start_time = (char *)malloc(sizeof(char) * (1 + strlen(arg.starttime)));
        strcpy(str_start_time, arg.starttime);
    }
    if (arg.endtime) {
        str_end_time = (char *)malloc(sizeof(char) * (1 + strlen(arg.endtime)));
        strcpy(str_end_time, arg.endtime);
    }
    if (arg.timeaccuracy) {
        str_time_accuracy = (char *)malloc(sizeof(char) * (1 + strlen(arg.timeaccuracy)));
        strcpy(str_time_accuracy, arg.timeaccuracy);
    }
    if (arg.country) {
        if (strcmp(arg.country, "N/A") != 0) {
            str_country = (char *)malloc(sizeof(char) * (1 + strlen(arg.country)));
            strcpy(str_country, arg.country);
        }
    }
    if (arg.state) {
        if (strcmp(arg.state, "N/A") != 0) {
            str_state = (char *)malloc(sizeof(char) * (1 + strlen(arg.state)));
            strcpy(str_state, arg.state);
        }
    }
    if (arg.city) {
        if (strcmp(arg.city, "N/A") != 0) {
            str_city = (char *)malloc(sizeof(char) * (1 + strlen(arg.city)));
            strcpy(str_city, arg.city);
        }
    }
    if (arg.outmutation) {
        str_outputMut = (char *)malloc(sizeof(char) * (1 + strlen(arg.outmutation)));
        strcpy(str_outputMut, arg.outmutation);
    }
    if (arg.outmeta) {
        str_outputMeta = (char *)malloc(sizeof(char) * (1 + strlen(arg.outmeta)));
        strcpy(str_outputMeta, arg.outmeta);
    }

    //while (1) {
    //    int this_option_optind = optind ? optind : 1;
    //    int option_index = 0;
    //    static struct option long_options[] = {
    //            {"input_mut",     required_argument, 0, 0},
    //            {"output_mut",    required_argument, 0, 0},
    //            {"input_meta",     required_argument, 0, 0},
    //            {"output_meta",    required_argument, 0, 0},
    //            {"outNumber", required_argument, 0, 0},
    //            {"ref", required_argument, 0, 0},
    //            {"start_time",     required_argument, 0, 0},
    //            {"end_time",     required_argument, 0, 0},
    //            {"time_accuracy",     required_argument, 0, 0},
    //            {"country",     required_argument, 0, 0},
    //            {"state",     required_argument, 0, 0},
    //            {"city",     required_argument, 0, 0},
    //            {"help", no_argument, 0, 0},
    //            {0, 0,                           0, 0}
    //    };
    //    c = getopt_long(argc, argv, "",
    //                    long_options, &option_index);
    //    if (c == -1)
    //        break;
    //    switch (c) {
    //        case 0:
    //            if (0 == strcmp(long_options[option_index].name, "input_mut")) {
    //                str_inputMut = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_inputMut, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "output_mut")) {
    //                str_outputMut = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_outputMut, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "input_meta")) {
    //                str_inputMeta = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_inputMeta, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "output_meta")) {
    //                str_outputMeta = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_outputMeta, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "outNumber")) {
    //                str_outNumber = (char *) malloc(sizeof(char) * (1 + strlen(optarg))); // the last char store '\0'
    //                strcpy(str_outNumber, optarg);
    //                numOfOutLine = atoi(str_outNumber);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "ref")) {
    //                str_ref = (char *) malloc(sizeof(char) * (1 + strlen(optarg))); // the last char store '\0'
    //                strcpy(str_ref, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "start_time")) {
    //                str_start_time = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_start_time, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "end_time")) {
    //                str_end_time = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_end_time, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "time_accuracy")) {
    //                str_time_accuracy = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                strcpy(str_time_accuracy, optarg);
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "country")) {
    //                if(strcmp(optarg, "N/A") != 0){
    //                    str_country = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                    strcpy(str_country, optarg);
    //                }
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "state")) {
    //                if(strcmp(optarg, "N/A") != 0){
    //                    str_state = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                    strcpy(str_state, optarg);
    //                }
    //            }
    //            else if (0 == strcmp(long_options[option_index].name, "city")) {
    //                if(strcmp(optarg, "N/A") != 0){
    //                    str_city = (char *) malloc(sizeof(char) * (1 + strlen(optarg)));
    //                    strcpy(str_city, optarg);
    //                }
    //            }
    //            break;
    //        case '?':
    //            break;

    //        default:
    //            printf("?? getopt returned character code 0%o ??\n", c);
    //    }
    //}

    //if (optind < argc) {
    //    printf("non-option ARGV-elements: ");
    //    while (optind < argc)
    //        printf("%s ", argv[optind++]);
    //    printf("\n");
    //}
    //if(true == bool_help){
    //    ;
    //}
    if(!str_inputVCF && !str_inputMut) {
        fprintf(stderr, "No input file.\n");
        exit(-1);
    }
    else if(str_inputVCF && str_inputMut) {
        fprintf(stderr, "Duplicate input file.\n");
        exit(-1);
    }
    else if(!str_inputMeta) {
        fprintf(stderr, "No input meta file.\n");
        exit(-1);
    }
    else if(!str_outputMut) {
        fprintf(stderr, "No output mutation file.\n");
        exit(-1);
    }
    else if(!str_outputMeta) {
        fprintf(stderr, "No output meta file.\n");
        exit(-1);
    }
    else{
        genDataset(str_inputVCF, str_inputMut, str_outputMut, str_inputMeta, str_outputMeta, numOfOutLine, str_ref, str_start_time, str_end_time, str_time_accuracy, str_country, str_state, str_city);
        //run
    }

    //free
    free(str_inputVCF);
    str_inputVCF = NULL;
    free(str_inputMut);
    str_inputMut = NULL;
    free(str_outputMut);
    str_outputMut = NULL;
    free(str_inputMeta);
    str_inputMeta = NULL;
    free(str_outputMeta);
    str_outputMeta = NULL;
    free(str_outNumber);
    str_outNumber = NULL;
    free(str_ref);
    str_ref = NULL;
    free(str_start_time);
    str_start_time = NULL;
    free(str_end_time);
    str_end_time = NULL;
    free(str_time_accuracy);
    str_time_accuracy = NULL;
    free(str_country);
    str_country = NULL;
    free(str_state);
    str_state = NULL;
    free(str_city);
    str_city = NULL;
}

int main_genDataset(int argc, char* argv[]) {
    opt_genDataset(argc, argv);
    printf("\nEND\n");
    return 0;
}
