//
// Created by lun on 3/12/21.
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "virus.h"
#include "haplotype.h"
#include "edges.h"

//#define DEBUG
void date2str(struct Date * date, char ** str);

char* getFullPathName(const char* str_folder, const char* filename) {
    if(!str_folder || !filename)
        return NULL;

    char *pathname = NULL;
    size_t l = strlen(str_folder) + strlen(filename) + 2;//2 for '\0' and '/'
    pathname = (char *)malloc(sizeof(char) * l);
    if (NULL == pathname) {
        fprintf(stderr, "Memory allocation failed\n");
        exit(EXIT_FAILURE);
    }
    strcpy(pathname, str_folder);
    strcat(pathname, "/");
    strcat(pathname, filename);
    return pathname;
}

void output_json(const char * str_folder, char * filename, char * json){
    char * str_json = getFullPathName(str_folder, filename);
    //size_t l = strlen(str_folder) + strlen(filename) + 2;//2 for '\0' and '/'
    //str_json = (char *)malloc(sizeof(char)*l);
    //if(NULL == str_json){
    //    fprintf(stderr, "malloc failed\n");
    //    exit(EXIT_FAILURE);
    //}
    //strcpy(str_json, str_folder);
    //strcat(str_json, "/");
    //strcat(str_json, filename);
#ifdef DEBUG
    printf("%s\n", str_json);
#endif

    FILE * fpout = fopen(str_json, "w");
    if(NULL == fpout){
        fprintf(stderr, "open file error!\n");
        exit(EXIT_FAILURE);
    }

    fprintf(fpout, "%s", json);

    fclose(fpout);
    fpout = NULL;
    free(str_json);
    str_json = NULL;
}

//void output_time(const char * str_folder, char * filename, double time){
//    char * str_time = NULL;
//    size_t l = strlen(str_folder) + strlen(filename) + 2;//2 for '\0' and '/'
//    str_time = (char *)malloc(sizeof(char)*l);
//    if(NULL == str_time){
//        exit(1);
//    }
//    strcpy(str_time, str_folder);
//    strcat(str_time, "/");
//    strcat(str_time, filename);
//#ifdef DEBUG
//    printf("%s\n", str_json);
//#endif
//    FILE * fpout = fopen(str_time, "w");
//    if(NULL == fpout){
//        printf("open file error!\n");
//        exit(EXIT_FAILURE);
//    }
//
//    fprintf(fpout, "%f s", time);
//
//    fclose(fpout);
//    fpout = NULL;
//    free(str_time);
//    str_time = NULL;
//}

//void output(const char * str_folder, char * json, long memoryUsed, double time){
//    output_json(str_folder, "haplotype_loci.json", json);
//    output_memory(str_folder, "memory", memoryUsed);
//    output_time(str_folder, "time", time);
//}

int outputHapsTSV(const char* str_folder, const char* filename, struct Virus* viruses, int numOfViruses, struct Hap* haps, int numOfHaps, struct Edge* edges, int* network, int numOfEdgesInNet, bool clustering) {
    //haplotype
    char *str_haps = getFullPathName(str_folder, filename);;
    //size_t l = strlen(str_folder) + strlen(filename) + 2;//2 for '\0' and '/'
    //str_haps = (char *) malloc(sizeof(char) * l);
    //if (NULL == str_haps) {
    //    fprintf(stderr, "Memory allocation failed for str_haps\n");
    //    return -1;
    //}
    //strcpy(str_haps, str_folder);
    //strcat(str_haps, "/");
    //strcat(str_haps, filename);
    FILE *fpout = fopen(str_haps, "w");
    if (NULL == fpout) {
        fprintf(stderr, "open file error!\n");
        return -1;
    }
    for (int i = 0; i < numOfHaps; ++i) {
        fprintf(fpout, "Node_%d\t", i);//node ID
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j!=0) {
                fprintf(fpout, ";");
            }
            fprintf(fpout, "%s",viruses[haps[i].allViruses[j]].acc);
        }
        fprintf(fpout, "\t");
        char tmp_mutType[20];
        if (haps[i].numOfMut==0) {
            fprintf(fpout, "N/A");
        }
        for (int j = 0; j < haps[i].numOfMut; ++j) {
            if(MUTATION_INDEL == haps[i].mutations[j].mutationType ){
                strcpy(tmp_mutType, "Indel");
            }
            else if(MUTATION_DELETION == haps[i].mutations[j].mutationType ){
                strcpy(tmp_mutType, "Deletion");
            }
            else if(MUTATION_INSERTION == haps[i].mutations[j].mutationType ){
                strcpy(tmp_mutType, "Insertion");
            }
            else if(MUTATION_SNP == haps[i].mutations[j].mutationType ){
                strcpy(tmp_mutType, "SNP");
            }
            if (j!=0) {
                fprintf(fpout, ";");
            }
            fprintf(fpout, "%d(%s:%s->%s)", haps[i].mutations[j].pos, tmp_mutType, haps[i].mutations[j].ref, haps[i].mutations[j].alt);
        }
        fprintf(fpout, "\n");
    }
    fclose(fpout);
    fpout = NULL;
    free(str_haps);
    str_haps = NULL;

    return 0;
}

int outputEdgesTSV(const char* str_folder, const char* filename, struct Virus* viruses, int numOfViruses, struct Hap* haps, int numOfHaps, struct Edge* edges, int* network, int numOfEdgesInNet, bool clustering) {
    //input str_folder, duration_all, edges, haplotype, network
    //edges
    char *str_edges = getFullPathName(str_folder, filename);
    //size_t l = strlen(str_folder) + strlen(filename) + 2;//2 for '\0' and '/'
    //str_edges = (char *) malloc(sizeof(char) * l);
    //if (NULL == str_edges) {
    //    fprintf(stderr, "Memory allocation failed for str_edges\n");
    //    return -1;
    //}
    //strcpy(str_edges, str_folder);
    //strcat(str_edges, "/");
    //strcat(str_edges, filename);
    FILE *fpout = fopen(str_edges, "w");
    if (NULL == fpout) {
        fprintf(stderr, "open file error!\n");
        return -1;
    }
    for (int i = 0; i < numOfEdgesInNet; ++i) {
        fprintf(fpout, "Node_%d\t", edges[network[i]].source);
        fprintf(fpout, "Node_%d\t", edges[network[i]].target);
        fprintf(fpout, "%d\n", edges[network[i]].distance);
    }
    fclose(fpout);
    fpout = NULL;
    free(str_edges);
    str_edges = NULL;

    return 0;
}

int outputGraphML(const char* str_folder, const char* filename, struct Virus* viruses, int numOfViruses, struct Hap* haps, int numOfHaps, struct Edge* edges, int* network, int numOfEdgesInNet, bool clustering) {
    char *str_graphml = getFullPathName(str_folder, filename);
    FILE *fpout = fopen(str_graphml, "w");
    if (NULL == fpout) {
        fprintf(stderr, "open file error!\n");
        return -1;
    }

    fprintf(fpout, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
    fprintf(fpout, "<!-- Created by McAN -->\n");
    fprintf(fpout, "<graphml xmlns=\"http://graphml.graphdrawing.org/xmlns\"\n");
    fprintf(fpout, "         xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
    fprintf(fpout, "         xsi:schemaLocation=\"http://graphml.graphdrawing.org/xmlns\n");
    fprintf(fpout, "                             http://graphml.graphdrawing.org/xmlns/1.0/graphml.xsd\">\n");

    fprintf(fpout, "  <key id=\"g_numOfViruses\" for=\"graph\" attr.name=\"numOfViruses\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"g_numOfEdges\" for=\"graph\" attr.name=\"numOfEdges\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"g_numOfHaps\" for=\"graph\" attr.name=\"numOfHaps\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"v_date\" for=\"node\" attr.name=\"date\" attr.type=\"string\"/>\n");
    if (clustering)
        fprintf(fpout, "  <key id=\"v_group\" for=\"node\" attr.name=\"group\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"v_numOfMut\" for=\"node\" attr.name=\"numOfMut\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"v_mutation\" for=\"node\" attr.name=\"mutation\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_numOfVirus\" for=\"node\" attr.name=\"numOfVirus\" attr.type=\"int\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_acc\" for=\"node\" attr.name=\"virus_acc\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_date\" for=\"node\" attr.name=\"virus_date\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_loc_1\" for=\"node\" attr.name=\"virus_loc_1\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_loc_2\" for=\"node\" attr.name=\"virus_loc_2\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_loc_3\" for=\"node\" attr.name=\"virus_loc_3\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"v_virus_name\" for=\"node\" attr.name=\"virus_name\" attr.type=\"string\"/>\n");
    fprintf(fpout, "  <key id=\"e_distance\" for=\"edge\" attr.name=\"distance\" attr.type=\"double\"/>\n");

    fprintf(fpout, "  <graph id=\"G\" edgedefault=\"directed\"\n");
    fprintf(fpout, "                parse.nodes=\"%d\" parse.edges=\"%d\"\n", numOfHaps, numOfEdgesInNet);
    fprintf(fpout, "                parse.nodeids=\"canonical\" parse.edgeids=\"canonical\"\n");
    fprintf(fpout, "                parse.order=\"nodesfirst\">\n");

    fprintf(fpout, "    <data key=\"g_numOfViruses\">%d</data>\n", numOfViruses);
    fprintf(fpout, "    <data key=\"g_numOfEdges\">%d</data>\n", numOfEdgesInNet);
    fprintf(fpout, "    <data key=\"g_numOfHaps\">%d</data>\n", numOfHaps);

    char tmpstr_date[11];
    char* ptr = tmpstr_date;
    tmpstr_date[10] = 0;

    for (int i = 0; i < numOfHaps; ++i) {
        fprintf(fpout, "    <node id=\"n%d\">\n", i);

        fprintf(fpout, "      <data key=\"v_date\">");
        if (haps[i].date) {
            date2str(haps[i].date, &ptr);
            fprintf(fpout, "%s", tmpstr_date);
        }
        else
            fprintf(fpout, "N/A");
        fprintf(fpout, "</data>\n");

        if (clustering)
            fprintf(fpout, "      <data key=\"v_group\">%d</data>\n", haps[i].group);

        fprintf(fpout, "      <data key=\"v_numOfMut\">%d</data>\n", haps[i].numOfMut);

        fprintf(fpout, "      <data key=\"v_mutation\">");
        static const char* mutTypeStr[] = { "Indel", "Deletion", "Insertion", "SNP" };
        if (haps[i].numOfMut == 0)
            fprintf(fpout, "N/A");
        for (int j = 0; j < haps[i].numOfMut; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            fprintf(fpout, "%d(%s:%s-&gt;%s)", haps[i].mutations[j].pos, mutTypeStr[haps[i].mutations[j].mutationType], haps[i].mutations[j].ref, haps[i].mutations[j].alt);
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_numOfVirus\">%d</data>\n", haps[i].numOfVirus);

        fprintf(fpout, "      <data key=\"v_virus_acc\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            fprintf(fpout, "%s", viruses[haps[i].allViruses[j]].acc);
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_virus_date\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            if (viruses[haps[i].allViruses[j]].date) {
                date2str(viruses[haps[i].allViruses[j]].date, &ptr);
                fprintf(fpout, "%s", tmpstr_date);
            }
            else
                fprintf(fpout, "N/A");
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_virus_loc_1\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            if (viruses[haps[i].allViruses[j]].location->country)
                fprintf(fpout, "%s", viruses[haps[i].allViruses[j]].location->country);
            else
                fprintf(fpout, "N/A");
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_virus_loc_2\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            if (viruses[haps[i].allViruses[j]].location->state)
                fprintf(fpout, "%s", viruses[haps[i].allViruses[j]].location->state);
            else
                fprintf(fpout, "N/A");
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_virus_loc_3\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            if (viruses[haps[i].allViruses[j]].location->city)
                fprintf(fpout, "%s", viruses[haps[i].allViruses[j]].location->city);
            else
                fprintf(fpout, "N/A");
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "      <data key=\"v_virus_name\">");
        for (int j = 0; j < haps[i].numOfVirus; ++j) {
            if (j != 0)
                fprintf(fpout, ";");
            if (viruses[haps[i].allViruses[j]].name && viruses[haps[i].allViruses[j]].name[0])
                fprintf(fpout, "%s", viruses[haps[i].allViruses[j]].name);
            else
                fprintf(fpout, "N/A");
        }
        fprintf(fpout, "</data>\n");

        fprintf(fpout, "    </node>\n");
    }

    for (int i = 0; i < numOfEdgesInNet; ++i) {
        fprintf(fpout, "    <edge id=\"e%d\" source=\"n%d\" target=\"n%d\">\n", i, edges[network[i]].source, edges[network[i]].target);
        fprintf(fpout, "      <data key=\"e_distance\">%d</data>\n", edges[network[i]].distance);
        fprintf(fpout, "    </edge>\n");
    }

    fprintf(fpout, "  </graph>\n");
    fprintf(fpout, "</graphml>\n");

    fclose(fpout);
    fpout = NULL;
    free(str_graphml);
    str_graphml = NULL;

    return 0;
}
